using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace TextPipeEngineDemo
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                txtFileName.Text = openFileDialog.FileName;
            }
        }

        private void btnRunTextPipeEngine_Click(object sender, EventArgs e)
        {
            TextPipeEngine.ApplicationClass tp = new TextPipeEngine.ApplicationClass();
            TextPipeEngine.FilterWindowClass f;
            f = (TextPipeEngine.FilterWindowClass)tp.newWindow();

            lblErr.Text = "Found version: " + tp.version();

            if (!f.openFilter(txtFileName.Text))
            {
                lblErr.Text = "Can not open file " + txtFileName.Text;
                return;
            }

            if (!string.IsNullOrEmpty(tp.errorText))
            {
                lblErr.Text = tp.errorText;
                return;
            }

            txtOutputText.Text = f.processString(txtInputText.Text);
            if (!string.IsNullOrEmpty(tp.errorText))
            {
                lblErr.Text = tp.errorText;
                return;
            }

            f = null;
            tp.quit();
            tp = null;
        }


        private void btRunTextPipe_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(txtFileName.Text))
            {
                lblErr.Text = "You didn't specified a filter file!";
                return;
            }

            if (!System.IO.File.Exists(txtFileName.Text))
            {
                lblErr.Text = "Can not open file " + txtFileName.Text;
                return;
            }

            TextPipe.Application tp = new TextPipe.Application();
            TextPipe.FilterWindow f = (TextPipe.FilterWindow)tp.newWindow();
            tp.calledFrom((System.Windows.Forms.Application.ProductName));

            lblErr.Text = "Found version: " + tp.version();

            if (!f.openFilter(txtFileName.Text))
            {
                lblErr.Text = "Can not open file " + txtFileName.Text;
                return;
            }

            if (!string.IsNullOrEmpty(tp.errorText))
            {
                lblErr.Text = tp.errorText;
                return;
            }

            txtOutputText.Text = f.processString(txtInputText.Text);
            if (!string.IsNullOrEmpty(tp.errorText))
            {
                lblErr.Text = tp.errorText;
                return;
            }

            f = null;
            tp.quit();
            tp = null;
        }


        private void btnEdit_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(txtFileName.Text))
            {
                MessageBox.Show("You didn't specified a filter file!", "TextPipeEngineDemo", MessageBoxButtons.OK);
            }

            if (!System.IO.File.Exists(txtFileName.Text))
            {
                MessageBox.Show("File not exists", "TestPipeEngine", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }

            TextPipe.Application tp = new TextPipe.Application();
            tp.findWindow(txtFileName.Text);
            tp.visible = true;
            tp.calledFrom((System.Windows.Forms.Application.ProductName));
            tp.bringToFront();
        }

    }
}